// ITypeAheadable.hh for FbTk - Fluxbox Toolkit
// Copyright (c) 2007 Fluxbox Team (fluxgen at fluxbox dot org)
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

#ifndef FBTK_ITYPEAHEADABLE_HH
#define FBTK_ITYPEAHEADABLE_HH

#include <string>

#ifdef HAVE_CCTYPE
  #include <cctype>
#else
  #include <ctype.h>
#endif // HAVE_CCTYPE

namespace FbTk {

// abstract base class providing access and validation
class ITypeAheadable {
public:
    virtual ~ITypeAheadable() { }

    virtual const std::string &iTypeString() const = 0;
    virtual bool isEnabled() { return true; }
    char iTypeChar(size_t i) const { return iTypeString()[i]; }
    bool iTypeCheckStringSize(size_t sz) const {
        return (iTypeString().size() > sz);
    }
    bool iTypeCompareChar(char ch, size_t sz) const {
        return (bool)iTypeCheckStringSize(sz) &&
               tolower(iTypeChar(sz)) == tolower(ch);
    }

};

} // end namespace FbTk

#endif // FBTK_ITYPEAHEADABLE_HH
